' ********************************************************
' *** ***
' *** Tiny-Reaktivlicht mit LDR und A/D-Wandler ***
' *** mit Watchdog-Energiesparmodus und Tagabschaltung ***
' *** ***
' ********************************************************

$regfile = "ATtiny84.DAT"
$crystal = 16000                                            'Frequenz des internen Oszillators
$hwstack = 3                                                'hardwarestack herabsetzen damit gengend variablen zur verfgung stehen

Config Adc = Single , Prescaler = Auto
Ddra = &B01111111
Porta = &B00000000                                          'Ausgnge auf Low setzen
Ddrb = &B00000001
Portb = &B00000000

Stop Ac                                                     'Analog-Komparator abschalten, um Strom zu sparen

Wdtcr = &B11010000                                          'Watchdog definieren: 0.125 Sekunden, Interrupt auslsen, kein Reset
Enable Interrupts                                           'Interrupts freigeben

Const Threshold = 15
Const Daylight = 950
Const Maxdigits = 512

Dim Ldr As Integer
Dim Daylightcounter As Integer

Dim Oldldr As Integer
Dim Deltaldr As Integer
Dim E As Byte
Dim J As Integer
Dim X As Integer

Do

  Start Adc
  Ldr = Getadc(7)
  Stop Adc
  Deltaldr = Ldr - Oldldr
  Oldldr = Ldr

  If Deltaldr > Threshold Then
    Gosub Show
    Oldldr = 1024
  End If

  If Ldr > Daylight Then
    If Daylightcounter < 255 Then
      Daylightcounter = Daylightcounter + 1
    End If
  Else
    Daylightcounter = 0
  End If
  If Daylightcounter > 200 Then
    Gosub Pause_8
  End If

  Gosub Pause_0125

Loop

Show:
   X = 0
   E = 0
   While E < 11 And X < Maxdigits
     Readeeprom E , X
     If E < 11 Then
        For J = 0 To 100
          Gosub Show_dig
        Next J
        Gosub Pause_0125
     End If
     X = X + 1
   Wend
Return

Pause_0125:
  Wdtcr = &B11010011
  Reset Watchdog
  Powerdown
Return

Pause_8:
  Wdtcr = &B11110001
  Reset Watchdog
  Powerdown
Return

Show_dig:
  If E = 0 Then
    Gosub Dig_0
  Elseif E = 1 Then
    Gosub Dig_1
  Elseif E = 2 Then
    Gosub Dig_2
  Elseif E = 3 Then
    Gosub Dig_3
  Elseif E = 4 Then
    Gosub Dig_4
  Elseif E = 5 Then
    Gosub Dig_5
  Elseif E = 6 Then
    Gosub Dig_6
  Elseif E = 7 Then
    Gosub Dig_7
  Elseif E = 8 Then
    Gosub Dig_8
  Elseif E = 9 Then
    Gosub Dig_9
  Elseif E = 10 Then
    Gosub Dig_dot
  End If
Return

Dig_dot:
  Portb.0 = 1
  Waitms 5
  Portb.0 = 0
  Waitms 5
  Waitms 5
  Waitms 5
  Waitms 5
  Waitms 5
  Waitms 5
Return

Dig_0:
  Porta.5 = 1
  Waitms 5
  Porta.5 = 0
  Porta.0 = 1
  Waitms 5
  Porta.0 = 0
  Porta.6 = 1
  Waitms 5
  Porta.6 = 0
  Porta.1 = 1
  Waitms 5
  Porta.1 = 0
  Porta.3 = 1
  Waitms 5
  Porta.3 = 0
  Porta.4 = 1
  Waitms 5
  Porta.4 = 0
  Waitms 5
Return

Dig_1:
  Waitms 5
  Porta.5 = 1
  Waitms 5
  Porta.5 = 0
  Porta.0 = 1
  Waitms 5
  Porta.0 = 0
  Waitms 5
  Waitms 5
  Waitms 5
  Waitms 5
Return

Dig_2:
  Porta.4 = 1
  Waitms 5
  Porta.4 = 0
  Porta.5 = 1
  Waitms 5
  Porta.5 = 0
  Waitms 5
  Porta.6 = 1
  Waitms 5
  Porta.6 = 0
  Porta.1 = 1
  Waitms 5
  Porta.1 = 0
  Waitms 5
  Porta.2 = 1
  Waitms 5
  Porta.2 = 0
Return

Dig_3:
  Porta.4 = 1
  Waitms 5
  Porta.4 = 0
  Porta.5 = 1
  Waitms 5
  Porta.5 = 0
  Porta.0 = 1
  Waitms 5
  Porta.0 = 0
  Porta.6 = 1
  Waitms 5
  Porta.6 = 0
  Waitms 5
  Waitms 5
  Porta.2 = 1
  Waitms 5
  Porta.2 = 0
Return

Dig_4:
  Waitms 5
  Porta.5 = 1
  Waitms 5
  Porta.5 = 0
  Porta.0 = 1
  Waitms 5
  Porta.0 = 0
  Waitms 5
  Waitms 5
  Porta.3 = 1
  Waitms 5
  Porta.3 = 0
  Porta.2 = 1
  Waitms 5
  Porta.2 = 0
Return

Dig_5:
  Porta.4 = 1
  Waitms 5
  Porta.4 = 0
  Waitms 5
  Porta.0 = 1
  Waitms 5
  Porta.0 = 0
  Porta.6 = 1
  Waitms 5
  Porta.6 = 0
  Waitms 5
  Porta.3 = 1
  Waitms 5
  Porta.3 = 0
  Porta.2 = 1
  Waitms 5
  Porta.2 = 0
Return

Dig_6:
  Porta.4 = 1
  Waitms 5
  Porta.4 = 0
  Porta.3 = 1
  Waitms 5
  Porta.3 = 0
  Porta.0 = 1
  Waitms 5
  Porta.0 = 0
  Porta.6 = 1
  Waitms 5
  Porta.6 = 0
  Porta.1 = 1
  Waitms 5
  Porta.1 = 0
  Waitms 5
  Porta.2 = 1
  Waitms 5
  Porta.2 = 0
Return

Dig_7:
  Porta.4 = 1
  Waitms 5
  Porta.4 = 0
  Porta.5 = 1
  Waitms 5
  Porta.5 = 0
  Porta.0 = 1
  Waitms 5
  Porta.0 = 0
  Waitms 5
  Waitms 5
  Waitms 5
  Waitms 5
Return

Dig_8:
  Porta.5 = 1
  Waitms 5
  Porta.5 = 0
  Porta.0 = 1
  Waitms 5
  Porta.0 = 0
  Porta.6 = 1
  Waitms 5
  Porta.6 = 0
  Porta.1 = 1
  Waitms 5
  Porta.1 = 0
  Porta.3 = 1
  Waitms 5
  Porta.3 = 0
  Porta.4 = 1
  Waitms 5
  Porta.4 = 0
  Porta.2 = 1
  Waitms 5
  Porta.2 = 0
Return

Dig_9:
  Porta.4 = 1
  Waitms 5
  Porta.4 = 0
  Porta.5 = 1
  Waitms 5
  Porta.5 = 0
  Porta.0 = 1
  Waitms 5
  Porta.0 = 0
  Porta.6 = 1
  Waitms 5
  Porta.6 = 0
  Waitms 5
  Porta.3 = 1
  Waitms 5
  Porta.3 = 0
  Porta.2 = 1
  Waitms 5
  Porta.2 = 0
Return

End